/*-------------------------------------------------------------------------
 *
 * pgsql_fdw.h
 *		  foreign-data wrapper for remote PostgreSQL servers.
 *
 * Copyright (c) 2012, PostgreSQL Global Development Group
 *
 * IDENTIFICATION
 *		  contrib/pgsql_fdw/pgsql_fdw.h
 *
 *-------------------------------------------------------------------------
 */

#ifndef PGSQL_FDW_H
#define PGSQL_FDW_H

#include "postgres.h"
#include "foreign/fdwapi.h"
#include "foreign/foreign.h"
#include "nodes/relation.h"

/* in option.c */
int ExtractConnectionOptions(List *defelems,
							 const char **keywords,
							 const char **values);
int GetFetchCountOption(ForeignTable *table, ForeignServer *server);

/* in deparse.c */
void deparseSimpleSql(StringInfo buf,
					  Oid relid,
					  PlannerInfo *root,
					  RelOptInfo *baserel);
void appendWhereClause(StringInfo buf,
					   bool has_where,
					   List *exprs,
					   PlannerInfo *root);
void sortConditions(PlannerInfo *root,
					RelOptInfo *baserel,
					List **remote_conds,
					List **param_conds,
					List **local_conds);
void deparseAnalyzeSql(StringInfo buf, Relation rel);

#endif /* PGSQL_FDW_H */
